## cassandra CQLSH

cassandra používa **cqlsh** (cassandra query language shell) -> pomocou neho vieme definovať schémy, vkladať dáta, a spúšťať dotazy 

príkaz **cqlsh** -> hodí nás priamo do interaktívneho cql shellu, podporuje aj argumenty pri spustení shellu, ako napr "cqlsh --no color (pustíme cql bez farieb)" alebo "cqlsh --debug (pre debug mode)"

## cassandra BIG DATA

Cassandra je **key-value** model -> vkladanie a vyberanie hodnoty podľa kľúča 

Cassandra -> najprv ukladá dáta do memtable ( a ak je preplnená ) udáje sa presunú permanentnej (SSTable).Táto vlastnosť ukladania dát je výhodná pre real-time dátach napríklad pri IoT. CQL je pomerne limitované čo sa requestov týka, preto je pri určitých tabuľáck v DB odporúčané spracovanie dát externými nástrojmi -> napríklad proces dát cez apache spark

Cassandra ponúka tiež lineárnu **škálovatelnosť**, čo je výhoda pri Big Data. Pri preplnení Datastorov/serverov na uzloch kde beží Cassandra, vieme bez downtimu pridať ďalšie nódy 

Veľká výhoda cassandry je možnosť nastavenia read/write **konzistencie**. 
**konzistencia** -> vlastnosť systému že každá operácia čítania musí čítať z najnovšieho zápisu Cassandra nám umožnuje túto konzistenciu nastavovať

## cassandra Page-rank

Page Rank -> ranking system pre web, hodnôt, primárne hodnotí podľa backlinkov

Page Rank pri implementácií pomocou matematických funkcií ukladá hyperlinky stránok ako číslo integeru -> to je jedna z priamych súvislostí, ku Cassandra data modelu ktorý je key-value storage 

Benefity PageRanku pri vyhľadávaní sú najviac viditelné pri pomerne nepresne špecifikovaných dotazoch -> to je priama výhoda pre Cassandru, kedže cassandra nepozná mnoho operácií ktoré napríklad SQL áno